## cutefish-screenlocker-0.5-2.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(screenlocker)
set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# set(CMAKE_AUTOUIC ON)
# set(CMAKE_AUTOMOC ON)
# set(CMAKE_AUTORCC ON)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckSymbolExists)
include(FeatureSummary)

find_package(Qt5 COMPONENTS Core DBus Widgets X11Extras Quick LinguistTools REQUIRED)
find_package(X11)

# ----------- Check --------------------

check_include_file("sys/prctl.h" HAVE_SYS_PRCTL_H)
check_symbol_exists(PR_SET_DUMPABLE "sys/prctl.h" HAVE_PR_SET_DUMPABLE)
check_include_file("sys/procctl.h" HAVE_SYS_PROCCTL_H)
check_symbol_exists(PROC_TRACE_CTL "sys/procctl.h" HAVE_PROC_TRACE_CTL)
if (HAVE_PR_SET_DUMPABLE OR HAVE_PROC_TRACE_CTL)
 set(CAN_DISABLE_PTRACE TRUE)
endif ()
add_feature_info("prctl/procctl tracing control"
                CAN_DISABLE_PTRACE
                "Required for disallowing ptrace on greeter and kcheckpass process")

check_include_file("sys/signalfd.h" HAVE_SIGNALFD_H)
if (NOT HAVE_SIGNALFD_H)
   check_include_files("sys/types.h;sys/event.h" HAVE_EVENT_H)
endif ()
add_feature_info("sys/signalfd.h"
                HAVE_SIGNALFD_H
                "Use the signalfd() api for signalhandling")
add_feature_info("sys/event.h"
                HAVE_EVENT_H
                "Use the kevent() and sigwaitinfo() api for signalhandling")

# --------------------------------------

option(PAM_REQUIRED "Require building with PAM" ON)

include(ConfigureChecks.cmake)

configure_file(config-workspace.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-workspace.h)
configure_file(config-unix.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-unix.h )
configure_file(config-X11.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-X11.h)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu90")

configure_file(config-screenlocker.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-screenlocker.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(screenlocker)
add_subdirectory(checkpass)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)


# Get the installation directory from qmake
get_target_property(QT_QMAKE_EXECUTABLE ${Qt5Core_QMAKE_EXECUTABLE} IMPORTED_LOCATION)
if(NOT QT_QMAKE_EXECUTABLE)
    message(FATAL_ERROR "qmake is not found.")
endif()

execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_QML
    OUTPUT_VARIABLE INSTALL_QMLDIR
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
if(INSTALL_QMLDIR)
    message(STATUS "qml directory:" "${INSTALL_QMLDIR}")
else()
    message(FATAL_ERROR "qml directory cannot be detected.")
endif()

# Install translations
file(GLOB TS_FILES translations/*.ts)
qt5_create_translation(QM_FILES ${TS_FILES})
add_custom_target(translations DEPENDS ${QM_FILES} SOURCES ${TS_FILES})
add_dependencies(cutefish-screenlocker translations)
install(FILES ${QM_FILES} DESTINATION /usr/share/cutefish-screenlocker/translations)

=== checkpass/CMakeLists.txt ===
include_directories( ${UNIXAUTH_INCLUDE_DIRS} )
check_include_files(paths.h HAVE_PATHS_H)
configure_file (config-ccheckpass.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-ccheckpass.h )

set(ccheckpass_SRCS
	checkpass.h
	checkpass.c
	checkpass_pam.c
	checkpass_shadow.c
)

# find_package(ECM REQUIRED NO_MODULE)
# set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} )
# include(ECMMarkNonGuiExecutable)

add_executable(ccheckpass ${ccheckpass_SRCS})
# ecm_mark_nongui_executable(ccheckpass)

set_property(TARGET ccheckpass APPEND_STRING PROPERTY COMPILE_FLAGS " -U_REENTRANT")
target_link_libraries(ccheckpass ${UNIXAUTH_LIBRARIES} ${SOCKET_LIBRARIES})

if (PAM_FOUND)
    set(checkpass_suid "")
else()
    set(checkpass_suid "SETUID")
    message(STATUS "PAM not found, will install a SUID-kcheckpass")
endif()
install(TARGETS ccheckpass
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE ${checkpass_suid}
    )

#EXTRA_DIST = README

=== screenlocker/CMakeLists.txt ===
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(PROJECT_SOURCES
    main.cpp
    application.cpp
    authenticator.cpp
    kcheckpass-enums.h
    fixx11h.h
    qml.qrc
)

add_executable(cutefish-screenlocker
    ${PROJECT_SOURCES}
)

target_link_libraries(cutefish-screenlocker
    PRIVATE
    Qt5::Core
    Qt5::DBus
    Qt5::Widgets
    Qt5::X11Extras
    Qt5::Quick

    ${X11_LIBRARIES}
)

install(TARGETS cutefish-screenlocker RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
cutefish-screenlocker (0.5) UNRELEASED; urgency=high

  * Initial release (CutefishOS)  <support@cutefishos.com>

 -- CutefishOS Packaging Team <support@cutefishos.com>  Thu, 16 Sep 2021 02:31:42 +0800

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>

pkgname=cutefish-screenlocker
pkgver=0.5
pkgrel=2
pkgdesc="CutefishOS system screen locker"
arch=('x86_64')
url="https://github.com/cutefishos/screenlocker"
license=('GPL')
groups=('cutefish')
depends=('fishui' 'libcutefish')
makedepends=('extra-cmake-modules' 'qt5-tools')
source=("https://github.com/cutefishos/screenlocker/archive/$pkgver/$pkgname-$pkgver.tar.gz")
sha512sums=('7b5c2064afe74ff036a840cb73ea51a0b203d4abd2756d983bd160b670374813d851a9b0f8fd0028d3dc3340c1947b8edd153ce4c9cd966d480f4e65fb9f8f76')

build() {
  cd screenlocker-$pkgver

  # https://github.com/cutefishos/screenlocker/issues/2
  cmake -DCMAKE_INSTALL_PREFIX=/usr -DKDE4_KSCREENSAVER_PAM_SERVICE=system-login .
  make
}

package() {
  cd screenlocker-$pkgver
  make DESTDIR="$pkgdir" install
}

=== debian/control ===
Source: cutefish-screenlocker
Section: devel
Priority: optional
Maintainer: CutefishOS <support@cutefishos.com>
Build-Depends: cmake,
               debhelper (>= 9),
               extra-cmake-modules,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtquickcontrols2-5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               libqt5x11extras5-dev,
               libpam0g-dev,
               libx11-dev
Standards-Version: 4.5.0
Homepage: https://cutefishos.com

Package: cutefish-screenlocker
Architecture: any
Depends: qml-module-qtquick-controls2,
         qml-module-qtquick2,
         qml-module-qtquick-layouts,
         qml-module-qt-labs-platform,
         qml-module-qt-labs-settings,
         qml-module-qtqml,
         qml-module-qtquick-window2,
         qml-module-qtquick-shapes,
         qml-module-qtquick-dialogs,
         ${misc:Depends},
         ${shlibs:Depends}
Description: CutefishOS Screen Locker
